//
//  C64ModelSettingsViewController.m
//  C64SceneBrowser
//
//  Created by Andreas Varga on 05.04.12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "C64ModelSettingsViewController.h"
#import "libx64/vice/src/arch/unix/ios/cocoa_touch/vicemachine.h"


@implementation C64ModelSettingsViewController


// ----------------------------------------------------------------------------
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
// ----------------------------------------------------------------------------
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}


// ----------------------------------------------------------------------------
- (void)viewDidLoad
// ----------------------------------------------------------------------------
{
    [super viewDidLoad];
    
	// Do any additional setup after loading the view.
}


// ----------------------------------------------------------------------------
- (void)viewDidUnload
// ----------------------------------------------------------------------------
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}


// ----------------------------------------------------------------------------
- (void) viewWillAppear:(BOOL)animated
// ----------------------------------------------------------------------------
{
//    CGSize currentSetSizeForPopover = self.contentSizeForViewInPopover;
//    CGSize fakeMomentarySize = CGSizeMake(360.0f, 400.0f);
//    self.contentSizeForViewInPopover = fakeMomentarySize;
//    self.contentSizeForViewInPopover = currentSetSizeForPopover;

    [super viewWillAppear:animated];
}


// ----------------------------------------------------------------------------
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
// ----------------------------------------------------------------------------
{
	return YES;
}



#pragma mark TableView delegate and datasource

// ----------------------------------------------------------------------------
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
// ----------------------------------------------------------------------------
{
    return 3;
}


// ----------------------------------------------------------------------------
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
// ----------------------------------------------------------------------------
{
    switch (section)
    {
        case 0:
            return 3;
        case 1:
            return 3;
        case 2:
            return 1;
    }
    
    return 0;
}    


// ----------------------------------------------------------------------------
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
// ----------------------------------------------------------------------------
{
    UITableViewCell* cell = nil;
    
    switch (indexPath.section)
    {
        case 0:
        case 1:
            switch (indexPath.row) 
            {
                case 0:
                    cell = [tableView dequeueReusableCellWithIdentifier:@"C64Cell"];
                    break;
                case 1:
                    cell = [tableView dequeueReusableCellWithIdentifier:@"C64CCell"];
                    break;
                case 2:
                    cell = [tableView dequeueReusableCellWithIdentifier:@"C64OldCell"];
                    break;
            }
            break;
        case 2:
            cell = [tableView dequeueReusableCellWithIdentifier:@"C64DreanCell"];
            break;
    }

    int current_model = [[theVICEMachine machineController] getModel];
    int section = current_model / 3;
    int row = current_model % 3;
    if (indexPath.row == row && indexPath.section == section)
        cell.accessoryType = UITableViewCellAccessoryCheckmark;
    else
        cell.accessoryType = UITableViewCellAccessoryNone;
    
    return cell;
}


// ----------------------------------------------------------------------------
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
// ----------------------------------------------------------------------------
{
    return NO;
}


// ----------------------------------------------------------------------------
- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section
// ----------------------------------------------------------------------------
{
    switch (section)
    {
        case 0:
            return @"PAL";
        case 1:
            return @"NTSC";
        case 2:
            return @"PAL-N";
    }
    
    return @"";
}


// ----------------------------------------------------------------------------
- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
// ----------------------------------------------------------------------------
{
    UITableViewCell* cell = [self tableView:tableView cellForRowAtIndexPath:indexPath];
    
    return cell.frame.size.height;
}


// ----------------------------------------------------------------------------
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
// ----------------------------------------------------------------------------
{
    NSInteger modelNumber = 3*indexPath.section+indexPath.row;
    //NSLog(@"Setting to model %d", modelNumber);

    int old_model = [[theVICEMachine machineController] getModel];
    int old_standard = old_model / 3;
    if (old_standard != indexPath.section)
    {
        _desiredModelNumber = modelNumber;
        
        UIAlertView* alertView = [[UIAlertView alloc] initWithTitle:@"WARNING" message:@"Switching TV standards causes demo to restart" delegate:self cancelButtonTitle:@"Cancel" otherButtonTitles:@"OK", nil];
        [alertView show];
    }
    else
    {
        NSNumber* value = [NSNumber numberWithInteger:modelNumber];
        [theVICEMachine performSelector:@selector(selectModel:) onThread:[theVICEMachine machineThread] withObject:value waitUntilDone:YES];
        [self.navigationController popViewControllerAnimated:YES];
    }
    
}


// ----------------------------------------------------------------------------
- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex
// ----------------------------------------------------------------------------
{
    if (buttonIndex > 0)
    {
        NSNumber* value = [NSNumber numberWithInteger:_desiredModelNumber];
        [theVICEMachine performSelector:@selector(selectModel:) onThread:[theVICEMachine machineThread] withObject:value waitUntilDone:YES];
        [theVICEMachine restart:[theVICEMachine autoStartPath]];
        [self.navigationController popViewControllerAnimated:YES];
    }
    else
    {
        NSInteger section = _desiredModelNumber / 3;
        int row = _desiredModelNumber % 3;
        NSIndexPath* indexPath = [NSIndexPath indexPathForRow:row inSection:section];
        [self.tableView deselectRowAtIndexPath:indexPath animated:NO];
    }
}

@end
