//
//  CSCreditItem.m
//  C64SceneBrowser
//
//  Created by Andreas Varga on 23.03.12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "CSCreditItem.h"
#import "CSScenerItem.h"
#import "CSReleaseItem.h"
#import "CSDatabaseCache.h"
#import "NSString+HTML.h"

@implementation CSCreditItem


@synthesize type = _type;
@synthesize scener = _scener;
@synthesize releaseItem = _releaseItem;


// ----------------------------------------------------------------------------
- (id)init
// ----------------------------------------------------------------------------
{
    self = [super init];
    if (self)
    {
        _type = nil;
        _scener = nil;
        _releaseItem = nil;
    }
    return self;
}


// ----------------------------------------------------------------------------
- (id) initWithXMLElement:(TBXMLElement*)creditElement
// ----------------------------------------------------------------------------
{
    self = [self init];
    if (self)
    {
        [self setFromXMLElement:creditElement];
    }
    return self;
}


// ----------------------------------------------------------------------------
- (void) setFromXMLElement:(TBXMLElement*)creditElement
// ----------------------------------------------------------------------------
{
    _type = [TBXML textForElement:[TBXML childElementNamed:@"CreditType" parentElement:creditElement] withStringEncoding:NSUTF8StringEncoding];
    
    TBXMLElement* handleElement = [TBXML childElementNamed:@"Handle" parentElement:creditElement];
    if (handleElement != NULL)
        _scener = [[CSScenerItem alloc] initWithXMLElement:handleElement];

    TBXMLElement* releaseElement = [TBXML childElementNamed:@"Release" parentElement:creditElement];
    if (releaseElement != NULL)
    {
        NSString* releaseId = [TBXML textForElement:[TBXML childElementNamed:@"ID" parentElement:releaseElement] withStringEncoding:NSUTF8StringEncoding];
        
        _releaseItem = (CSReleaseItem*)[[CSDatabaseCache sharedInstance] itemForType:CSDB_RELEASE withIdentifier:releaseId];
        if (_releaseItem.cached_depth < 1)
        {
            [_releaseItem setFromXMLElement:releaseElement];
            _releaseItem.cached_depth = 1;
        }
    }
}


// ----------------------------------------------------------------------------
- (NSComparisonResult) compare:(CSCreditItem*)other
// ----------------------------------------------------------------------------
{
    return [_scener.handle compare:other.scener.handle];
}


@end
