//
//  CSDatabaseCache.h
//  C64SceneBrowser
//
//  Created by Andreas Varga on 27.03.12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "CSDatabaseItem.h"

@class CSReleaseItem;
@class CSScenerItem;

@protocol CSReleaseViewerDelegate <NSObject>

@property (nonatomic) CSReleaseItem* selectedReleaseItem;

@end


@protocol CSScenerViewerDelegate <NSObject>

@property (nonatomic) CSScenerItem* selectedScenerItem;

@end



@interface CSDatabaseCache : NSObject
{
    NSString*                   _releasesPath;
    NSString*                   _scenersPath;
    NSString*                   _favoritesPath;
    NSMutableArray*             _favorites;
}


@property (nonatomic) NSMutableDictionary* releaseDictionary;
@property (nonatomic) NSMutableDictionary* userDictionary;
@property (nonatomic) NSMutableDictionary* scenerDictionary;
@property (nonatomic) NSMutableDictionary* groupDictionary;
@property (nonatomic) NSMutableDictionary* eventDictionary;


+ (CSDatabaseCache*) sharedInstance;

- (NSString*) releasesPath;
- (NSMutableArray*) favorites;

- (CSDatabaseItem*) itemForType:(CSDatabaseItemType)type withIdentifier:(NSString*)identifier;

- (void) writeTimeStampFile:(CSDatabaseItem*)item;
- (NSTimeInterval) readTimeStamp:(NSString*)identifier ofType:(CSDatabaseItemType)type;

- (void) writeItem:(CSDatabaseItem*)item withData:(NSData*)data;
- (BOOL) readItem:(CSDatabaseItem*)item;

- (void) writeDownloadFiles:(NSArray*)downloadFiles forReleaseId:(NSString*)releaseId;
- (NSArray*) readDownloadFilesForReleaseId:(NSString*)releaseId;

- (void) addFavorite:(NSString*)releaseId;
- (void) removeFavorite:(NSString*)releaseId;

- (NSString*) cachePathForItem:(CSDatabaseItem*)item;
- (NSString*) cachePathForId:(NSString*)identifier ofType:(CSDatabaseItemType)type;

- (NSString*) releasePathForReleaseId:(NSString*)releaseId;

- (void) showNetworkError;

- (NSString*) stringForDate:(NSDateComponents*)date short:(BOOL)shortFormat;

@end
