//
//  CSScenerItem.h
//  C64SceneBrowser
//
//  Created by Andreas Varga on 23.03.12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "CSDatabaseItem.h"
#import "SDWebImageManager.h"
#import "TBXML.h"


@interface CSScenerItem : CSDatabaseItem <SDWebImageManagerDelegate>


@property (strong, nonatomic) NSString* handle;
@property (strong, nonatomic) NSString* alternativeHandle;
@property (strong, nonatomic) UIImage* photo;
@property (strong, nonatomic) NSString* country;
@property (strong, nonatomic) NSMutableArray* memberOf;
@property (strong, nonatomic) NSMutableArray* released;
@property (strong, nonatomic) NSMutableDictionary* creditsDictionary;
@property (strong, nonatomic) NSMutableArray* sortedCreditReleases;
@property (strong, nonatomic) NSMutableArray* attendedEvents;
@property (strong, nonatomic) NSMutableArray* organizedEvents;

- (id) initWithScenerId:(NSString*)scenerId;

- (id) initWithXMLElement:(TBXMLElement*)handleElement;
- (id) setFromXMLElement:(TBXMLElement*)handleElement;

@end


@class CSGroupItem;

@interface CSMemberOfItem : NSObject

@property (strong, nonatomic) CSGroupItem* group;
@property (strong, nonatomic) NSMutableArray* professions;
@property (strong, nonatomic) NSDateComponents* joinDate;
@property (strong, nonatomic) NSDateComponents* leaveDate;
@property (nonatomic) BOOL hasValidDates;
@property (strong, nonatomic) NSString* status;


- (id) initWithXMLElement:(TBXMLElement*)memberOfElement;
- (id) setFromXMLElement:(TBXMLElement*)memberOfElement;

- (NSComparisonResult) compare:(CSMemberOfItem*)otherItem;

@end
