//
//  CSUserItem.m
//  C64SceneBrowser
//
//  Created by Andreas Varga on 22.03.12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "CSUserItem.h"
#import "CSDatabaseCache.h"
#import "NSString+HTML.h"

@implementation CSUserItem

@synthesize user_id = _user_id;
@synthesize name = _name;
@synthesize scener = _scener;


// ----------------------------------------------------------------------------
- (id)init
// ----------------------------------------------------------------------------
{
    self = [super init];
    if (self)
    {
        _user_id = nil;
        _name = nil;
        _scener = nil;
    }
    return self;
}


// ----------------------------------------------------------------------------
- (id) initWithXMLElement:(TBXMLElement*)userElement
// ----------------------------------------------------------------------------
{
    self = [self init];
    if (self)
    {
        self = [self setFromXMLElement:userElement];
    }
    return self;
}


// ----------------------------------------------------------------------------
- (id) setFromXMLElement:(TBXMLElement*)userElement
// ----------------------------------------------------------------------------
{
    TBXMLElement* userIdElement = [TBXML childElementNamed:@"ID" parentElement:userElement];
    if (userIdElement != NULL)
        _user_id = [TBXML textForElement:userIdElement];
    
    if (_user_id != nil)
    {
        CSUserItem* existing_user = [[CSDatabaseCache sharedInstance].userDictionary objectForKey:_user_id];
        if (existing_user != nil)
            return existing_user;
        else
            [[CSDatabaseCache sharedInstance].userDictionary setObject:self forKey:_user_id];
        
        TBXMLElement* handleElement = [TBXML childElementNamed:@"Handle" parentElement:userElement];
        if (handleElement != NULL)
        {
            _name = [TBXML textForElement:handleElement withStringEncoding:NSUTF8StringEncoding];
            _name = [_name stringByReplacingOccurrencesOfString:@"&amp;" withString:@"&"];
            _name = [_name stringByDecodingHTMLEntities];
        }
        else
        {
            TBXMLElement* loginElement = [TBXML childElementNamed:@"Login" parentElement:userElement];
            if (loginElement != NULL)
                _name = [TBXML textForElement:loginElement withStringEncoding:NSUTF8StringEncoding];
        }
    }
    
    return self;
}

@end
