//
//  DetailViewController.h
//  C64SceneBrowser
//
//  Created by Andreas Varga on 16.03.12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "GMGridView.h"
#import "MasterViewController.h"
#import "ReleaseViewController.h"
#import "CSReleaseItem.h"


@class SSLoadingView;

#define BLACK_MODE


@class OverviewItem;


@interface DetailViewController : UIViewController <UISplitViewControllerDelegate, CSReleaseViewerDelegate, GMGridViewDataSource, GMGridViewActionDelegate, CSDatabaseItemDelegate>
{
    IBOutlet GMGridView*                    _gridView;
    IBOutlet UIView*                        _noFavoritesView;
    IBOutlet UIView*                        _noRecentsView;
    
    OverviewType                            _viewMode;
    NSMutableArray*                         _items;
    NSURLConnection*                        _releaseListUrlConnection;
    NSMutableData*                          _releaseListData;
    SSLoadingView*                          _loadingView;
    BOOL                                    _addLoadMoreItem;
    int                                     _releasesLoaded;
    BOOL                                    _loadingMoreItems;
    BOOL                                    _isPortrait;
    NSMutableArray*                         _recentlyViewedReleaseIds;
}

@property (nonatomic) OverviewItem* overviewItem;
@property (nonatomic) CSReleaseItem* selectedReleaseItem;
@property (nonatomic) BOOL isAppearing;

- (void) configureView;
- (void) clickEditButton:(id)sender;


@end

