//
//  DownloadListViewController.m
//  C64SceneBrowser
//
//  Created by Andreas Varga on 17.10.13.
//
//

#import "DownloadListViewController.h"
#import "ReleaseViewController.h"


@implementation DownloadListViewController


@synthesize downloadList = _downloadList;
@synthesize downloadListPopOver = _downloadListPopOver;
@synthesize releaseViewController = _releaseViewController;


// ----------------------------------------------------------------------------
- (id)initWithStyle:(UITableViewStyle)style
// ----------------------------------------------------------------------------
{
    self = [super initWithStyle:style];
    if (self)
    {
        _downloadList = nil;
    }
    return self;
}


// ----------------------------------------------------------------------------
- (void)viewDidLoad
// ----------------------------------------------------------------------------
{
    [super viewDidLoad];
}


// ----------------------------------------------------------------------------
- (void)didReceiveMemoryWarning
// ----------------------------------------------------------------------------
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


// ----------------------------------------------------------------------------
- (IBAction)dismiss:(id)sender
// ----------------------------------------------------------------------------

{
    [self dismissViewControllerAnimated:YES completion:NULL];
}


#pragma mark TableView delegate and datasource

// ----------------------------------------------------------------------------
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
// ----------------------------------------------------------------------------
{
    return 1;
}


// ----------------------------------------------------------------------------
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
// ----------------------------------------------------------------------------
{
    if (_downloadList == nil)
        return 1;
    else
        return _downloadList.count;
}


// ----------------------------------------------------------------------------
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
// ----------------------------------------------------------------------------
{
    UITableViewCell* cell = [tableView dequeueReusableCellWithIdentifier:@"Cell"];
    
    if (_downloadList == nil || _downloadList.count == 0)
        cell.textLabel.text = @"No downloads available";
    else
    {
        cell.textLabel.text = [[_downloadList objectAtIndex:indexPath.row] lastPathComponent];
        cell.accessoryType = UITableViewCellAccessoryNone;
    }
    
    return cell;
}


// ----------------------------------------------------------------------------
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
// ----------------------------------------------------------------------------
{
    return NO;
}


// ----------------------------------------------------------------------------
- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section
// ----------------------------------------------------------------------------
{
    return @"";
}


// ----------------------------------------------------------------------------
- (NSIndexPath *)tableView:(UITableView *)tableView willSelectRowAtIndexPath:(NSIndexPath *)indexPath
// ----------------------------------------------------------------------------
{
    if (_downloadList == nil)
        return nil;
    
    return indexPath;
}


// ----------------------------------------------------------------------------
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
// ----------------------------------------------------------------------------
{
    if (_downloadList == nil)
        return;

    if (_downloadListPopOver != nil)
        [_downloadListPopOver dismissPopoverAnimated:YES];
    else
        [self dismissViewControllerAnimated:YES completion:NULL];
    
    if (_releaseViewController != nil)
    {
        _releaseViewController.selectedDownloadIndex = indexPath.row;
        [_releaseViewController playRelease:self];
    }
}


/*
#pragma mark - Navigation

// In a story board-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}

 */

@end
