//
//  OscilloscopeView.m
//  C64SceneBrowser
//
//  Created by Andreas Varga on 29/10/2016.
//
//

#import "OscilloscopeView.h"


@implementation OscilloscopeView


// ----------------------------------------------------------------------------
- (void) awakeFromNib
// ----------------------------------------------------------------------------
{
    [super awakeFromNib];
    
    _audioBuffer = NULL;
    _renderingLock = [[NSLock alloc] init];
}


// ----------------------------------------------------------------------------
- (void) setAudioBuffer:(short*)buffer
// ----------------------------------------------------------------------------
{
//    [_renderingLock lock];
//    _audioBuffer = buffer;
//    [_renderingLock unlock];
}

    
extern "C" short* gGetCurrentAudioBuffer();

// ----------------------------------------------------------------------------
- (void) drawRect:(CGRect)rect
// ----------------------------------------------------------------------------
{
    //CGRect bounds = [self bounds];
    
//    [_renderingLock lock];
    
    CGRect contextRect;
    contextRect.origin.x = rect.origin.x;
    contextRect.origin.y = rect.origin.y;
    contextRect.size.width = rect.size.width;
    contextRect.size.height = rect.size.height;
    
    CGContextRef context = UIGraphicsGetCurrentContext();
    
    CGContextSetRGBFillColor(context, 0.0f, 0.0f, 0.0f, 1.0f);
    CGContextFillRect(context, contextRect);
    
    float fadeVolume = 1.0f;
    
    bool isPlaying = true;
    
    float zeroLineHeight = contextRect.size.height * 0.5f + 0.5f;
    float width = contextRect.size.width;
    float height = contextRect.size.height;
    
    if (isPlaying)
        CGContextSetRGBStrokeColor(context, 0.2f, 1.0f, 1.0f, 1.0f);
    else
    {
        float error = 0.1f * (random() & 0xffff) / 65535.0f;
        float brightness = error + 0.9f;
        
        CGContextSetRGBStrokeColor(context, 0.2f, brightness, brightness, 1.0f);
    }
    
    CGContextBeginPath(context);
    CGContextSetLineWidth(context, 1.2f);
    
    _audioBuffer = gGetCurrentAudioBuffer();
    if (isPlaying && _audioBuffer != NULL)
    {
        //printf("audioBuffer: %p\n", _audioBuffer);
        
        static CGPoint linePoints[1024];
        
        for (int i = 0; i < width; i++)
        {
            linePoints[i].x = i + 0.5f;
            linePoints[i].y = zeroLineHeight + fadeVolume * (_audioBuffer[i] * height / 65536.0f);
        }
        
        CGContextAddLines(context, linePoints, width);
        CGContextDrawPath(context, kCGPathStroke);
    }
    else
    {
        static CGPoint linePoints[2];
        linePoints[0].x = contextRect.origin.x;
        linePoints[0].y = zeroLineHeight;
        linePoints[1].x = width;
        linePoints[1].y = zeroLineHeight;
        
        CGContextAddLines(context, linePoints, 2);
        CGContextDrawPath(context, kCGPathFillStroke);
    }
    
//    [_renderingLock unlock];
}

@end
