//
//  ScenerViewController.h
//  C64SceneBrowser
//
//  Created by Andreas Varga on 11.05.12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <MapKit/MapKit.h>
#import <CSDatabaseItem.h>
#import "ReleaseViewController.h"

@class CSScenerItem;
@class CSReleaseItem;
@class SSLoadingView;


enum ScenerViewMode
{
    SCENER_VIEW_CREDITS,
    SCENER_VIEW_RELEASES,
    SCENER_VIEW_EVENTS
};




@interface ScenerViewController : UIViewController <CSDatabaseItemDelegate, CSReleaseViewerDelegate, CSScenerViewerDelegate, UIActionSheetDelegate>
{
    IBOutlet UILabel*               _handleLabel;
    IBOutlet UILabel*               _groupsLabel;
    IBOutlet UILabel*               _professionsLabel;
    IBOutlet UIImageView*           _photoView;
    IBOutlet MKMapView*             _mapView;
    IBOutlet UITableView*           _scenerItemsTableView;
    IBOutlet UIBarButtonItem*       _membershipButton;
    IBOutlet UIView*                _barView;
    IBOutlet UIButton*              _creditsButton;
    IBOutlet UIButton*              _releasesButton;
    IBOutlet UIButton*              _eventsButton;
    
    CSScenerItem*                   _previousScenerItem;
    
    UIActionSheet*                  _actionSheet;
    
    SSLoadingView*                  _releasesLoadingView;
    
    UIPopoverController*            _membershipPopOver;
    
    ScenerViewMode                  _scenerViewMode;
}

@property (nonatomic) CSScenerItem* scenerItem;
@property (nonatomic) CSReleaseItem* selectedReleaseItem;
@property (nonatomic) BOOL isAppearing;


- (IBAction) openInSafari:(id)sender;
- (IBAction) clickMembershipButton:(id)sender;
- (IBAction) setScenerViewMode:(id)sender;

@end


@interface ReleaseItemCell : UITableViewCell
{
}

@property (nonatomic) IBOutlet UILabel* nameLabel;
@property (nonatomic) IBOutlet UIImageView* screenshotImageView;
@property (nonatomic) IBOutlet UILabel* typeLabel;
@property (nonatomic) IBOutlet UILabel* eventLabel;
@property (nonatomic) IBOutlet UILabel* ratingLabel;
@property (nonatomic) IBOutlet UILabel* ratingStarsLabel;
@property (nonatomic) IBOutlet UILabel* ratingStarsBackgroundLabel;

@end


@interface ScenerCreditItemCell : UITableViewCell
{
}

@property (nonatomic) IBOutlet UILabel* nameLabel;
@property (nonatomic) IBOutlet UIImageView* screenshotImageView;
@property (nonatomic) IBOutlet UILabel* typeLabel;
@property (nonatomic) IBOutlet UILabel* creditsLabel;
@property (nonatomic) IBOutlet UILabel* ratingLabel;
@property (nonatomic) IBOutlet UILabel* ratingStarsLabel;
@property (nonatomic) IBOutlet UILabel* ratingStarsBackgroundLabel;


@end


@interface EventItemCell : UITableViewCell
{
}

@property (nonatomic) IBOutlet UILabel* nameLabel;
@property (nonatomic) IBOutlet UILabel* taglineLabel;
//@property (nonatomic) IBOutlet UILabel* datesLabel;


@end


@interface ScenerInfoItemCell : UITableViewCell
{
    
}

- (void) updateViewModeButtons:(ScenerViewMode)mode;

@property (nonatomic) IBOutlet UILabel*               handleLabel;
@property (nonatomic) IBOutlet UILabel*               groupsLabel;
@property (nonatomic) IBOutlet UILabel*               professionsLabel;
@property (nonatomic) IBOutlet UIImageView*           photoView;
@property (nonatomic) IBOutlet UIButton*              creditsButton;
@property (nonatomic) IBOutlet UIButton*              releasesButton;
@property (nonatomic) IBOutlet UIButton*              eventsButton;

@end
